%define anolis_release 1
# Recent so-version, so we do not bump accidentally.
%global nettle_so_ver 8
%global hogweed_so_ver 6

%bcond_without fips

Name:           nettle
Version:        3.9.1
Release:        %{anolis_release}%{?dist}
Summary:        A low-level cryptographic library

License:        LGPLv3+ or GPLv2+
URL:            http://www.lysator.liu.se/~nisse/nettle/
Source0:        https://ftp.gnu.org/gnu/nettle/%{name}-%{version}.tar.gz

BuildRequires:	make
BuildRequires:  gcc
BuildRequires:  gmp-devel >= 1:6.1.0
BuildRequires:	gettext
BuildRequires:	m4
BuildRequires:	texinfo
%if %{with fips}
BuildRequires:  fipscheck
%endif

%package devel
Summary:        Development headers for a low-level cryptographic library
Requires:       %{name} = %{version}-%{release}
Requires:       gmp-devel >= 1:6.1.0

%description
Nettle is a cryptographic library that is designed to fit easily in more
or less any context: In crypto toolkits for object-oriented languages
(C++, Python, Pike, ...), in applications like LSH or GNUPG, or even in
kernel space.

%description devel
Nettle is a cryptographic library that is designed to fit easily in more
or less any context: In crypto toolkits for object-oriented languages
(C++, Python, Pike, ...), in applications like LSH or GNUPG, or even in
kernel space.  This package contains the files needed for developing 
applications with nettle.

%package tools
Summary:	Tools shipped with %{name}
Requires:	%{name} = %{version}-%{release}

%description tools
This package contains binary utilities that accompany the library:

  - nettle-lfib-stream - generates a pseudo-random stream, using the Knuth
    lfib (non-cryptographic) pseudo-random generator.
  - sexp-conv - conversion tool for handling the different flavours of sexp
    syntax.
  - pkcs1-conv - converts PKCS#1 keys to sexp format.
  - nettle-hash - command-line tool to compute message digests such as SHA-1.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1

%build
%configure --enable-shared --disable-static --enable-fat --disable-openssl
%make_build

%if %{with fips}
%define fipshmac() \
	fipshmac -d $RPM_BUILD_ROOT%{_libdir} $RPM_BUILD_ROOT%{_libdir}/%1.* \
	file=`basename $RPM_BUILD_ROOT%{_libdir}/%1.*.hmac` && \
	mv $RPM_BUILD_ROOT%{_libdir}/$file $RPM_BUILD_ROOT%{_libdir}/.$file && \
	ln -s .$file $RPM_BUILD_ROOT%{_libdir}/.%1.hmac

%define __spec_install_post \
	%{?__debug_package:%{__debug_install_post}} \
	%{__arch_install_post} \
	%{__os_install_post} \
	%fipshmac libnettle.so.%{nettle_so_ver} \
	%fipshmac libhogweed.so.%{hogweed_so_ver} \
	%{?bootstrap_fips:%fipshmac libnettle.so.%{nettle_so_ver_old}} \
	%{?bootstrap_fips:%fipshmac libhogweed.so.%{hogweed_so_ver_old}} \
%{nil}
%endif


%install
%make_install

%generate_compatibility_deps

%check
make check

%files
%license COPYINGv2 COPYING.LESSERv3
%{_infodir}/nettle.info.*
%{_libdir}/libnettle.so.%{nettle_so_ver}
%{_libdir}/libnettle.so.%{nettle_so_ver}.*
%{_libdir}/libhogweed.so.%{hogweed_so_ver}
%{_libdir}/libhogweed.so.%{hogweed_so_ver}.*
%{abidir}/*.dump
%if %{with fips}
%{_libdir}/.libhogweed.so.*.hmac
%{_libdir}/.libnettle.so.*.hmac
%endif

%files doc
%doc AUTHORS NEWS README

%files tools
%{_bindir}/*
%{abidir}/*-option.list

%files devel
%doc descore.README nettle.html nettle.pdf
%{_includedir}/nettle
%{_libdir}/libnettle.so
%{_libdir}/libhogweed.so
%{_libdir}/pkgconfig/hogweed.pc
%{_libdir}/pkgconfig/nettle.pc

%changelog
* Wed Jun 28 2023 Funda Wang <fundawang@yeah.net> - 3.9.1-1
- New version 3.9.1

* Thu May 18 2023 Funda Wang <fundawang@yeah.net> - 3.9-1
- New version 3.9

* Sun Dec 4 2022 Funda Wang <fundawang@yeah.net> - 3.8.1-1
- New version 3.8.1

* Wed Sep 21 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.8-1
- update to 3.8

* Tue Mar  8 2022 Liwei Ge <liwei.glw@linux.alibaba.com> - 3.7.3-1
- Init version from upstream v3.7.3
